/*****************************************************************************
 *
 *  MLib platform-specific configuration file
 *
 *    detection directives for the Borland C++
 *
 *  this file is used to compute platform-specific configuration macros,
 *  based on the current compiler setup.
 *
 *  note that we cannot use run-time checks on the host machine to
 *  determine the target endianess.
 *
 *  All configuration macros are _optional_, i.e. they're not required
 *  to compile the MLib. However, certain features or the library will
 *  not be compiled when some "features" are missing
 *
 *  for a list of macros, see the file MLIB_COMPILATION_OPTIONS
 *
 *****************************************************************************/

#ifndef __MLIB_COMPILER_BORLAND_CPP_H__
#define __MLIB_COMPILER_BORLAND_CPP_H__

/* determine endianess - for now, be really simple !! */

#ifdef __BORLANDC__

/* as far as I know, BC++ only compiles code for x86 processors */
#  define M_CONFIG_HAS_ENDIANESS
#  define M_CONFIG_LITTLE_ENDIAN

/* do we have an inline keyword ? */
#  define  M_CONFIG_HAS_INLINE
#  define  M_INLINE  __inline

/* do we have a 64-bits integer ? */
#  define  M_CONFIG_HAS_INT64
#  define  M_INT64_T       __int64
#  define  M_INT64_FMT_0   "I64"

/* DLL import/export macros */
#  define  M_DLL_IMPORT(x)          x __declc(dllimport)
#  define  M_DLL_EXPORT(x)          x
#  define  M_DLL_EXPORT_LAZY(x)     x __declc(dllexport)

/* name of the current function */
#  define  M__FUNCTION__        __FUNC__

/* we're on a x86 cpu, and on Win32 (check OS/2 ?) */
#  define  M_OS         M_OS_WIN32
#  define  M_CPU        M_CPU_X86

#endif /* __BORLANDC__ */

#endif /* __MLIB_COMPILER_BORLAND_CPP_H__ */

