/*****************************************************************************
 *
 *  MLib platform-specific configuration file
 *
 *    detection directives for the MetroWerks CodeWarrior compiler
 *
 *  this file is used to compute platform-specific configuration macros,
 *  based on the current compiler setup.
 *
 *  note that we cannot use run-time checks on the host machine to
 *  determine the target endianess.
 *
 *  All configuration macros are _optional_, i.e. they're not required
 *  to compile the MLib. However, certain features or the library will
 *  not be compiled when some "features" are missing
 *
 *  for a list of macros, see the file MLIB_COMPILATION_OPTIONS
 *
 *****************************************************************************/

#ifndef __MLIB_COMPILER_CODEWARRIOR_H__
#define __MLIB_COMPILER_CODEWARRIOR_H__

#ifdef __MWKS__

/* determine endianess of target processor */
#  if __POWERPC__
#
#    define M_CONFIG_HAS_ENDIANESS
#    define M_CONFIG_BIG_ENDIAN
#    define M_CPU  M_CPU_POWERPC
#
#  elif __MC68K__
#
#    define M_CONFIG_HAS_ENDIANESS
#    define M_CONFIG_BIG_ENDIAN
#    define M_CPU  M_CPU_68K
#
#  elif __INTEL__
#
#    define M_CONFIG_HAS_ENDIANESS
#    define M_CONFIG_LITTLE_ENDIAN
#    define M_CPU  M_CPU_X86
#
#  endif /* __INTEL__ */

/* I don't know if CodeWarrior has an "inline" keyword */
#  undef  M_CONFIG_HAS_INLINE

/* I don't know if CodeWarrior has a 64-bit type */
#  undef  M_CONFIG_HAS_INT64

#endif /* __MKWS__ */

#endif /* __MLIB_COMPILER_CODEWARRIOR_H__ */

