/*****************************************************************************
 *
 *  MLib platform-specific configuration file
 *
 *    detection directives for the Microsoft Visual C++
 *
 *  this file is used to compute platform-specific configuration macros,
 *  based on the current compiler setup.
 *
 *  note that we cannot use run-time checks on the host machine to
 *  determine the target endianess.
 *
 *  All configuration macros are _optional_, i.e. they're not required
 *  to compile the MLib. However, certain features or the library will
 *  not be compiled when some "features" are missing
 *
 *  for a list of macros, see the file MLIB_COMPILATION_OPTIONS
 *
 *****************************************************************************/

#ifndef __MLIB_COMPILER_VISUAL_CPP_H__
#define __MLIB_COMPILER_VISUAL_CPP_H__

/* determine endianess - for now, be really simple !! */

#ifdef _MSC_VER

/* to date, only runs on Win32, is it ?? */
#  ifdef _WIN32
#    define  M_OS  M_OS_WIN32
#  endif

/* determine processor + endianess */
#  ifdef _M_ALPHA
#
#    define  M_CPU  M_CPU_ALPHA
#    define  M_CONFIG_HAS_ENDIANESS
#    define  M_CONFIG_BIG_ENDIAN
#
#  elif defined(_M_IX86)
#
#    define  M_CPU  M_CPU_X86
#    define  M_CONFIG_HAS_ENDIANESS
#    define  M_CONFIG_LITTLE_ENDIAN
#
#  elif defined(_M_MPPC) || defined(_M_PPC)  /* does it really exist ?? */
#
#    define  M_CPU  M_CPU_POWERPC
#    define  M_CONFIG_HAS_ENDIANESS
#    define  M_CONFIG_BIG_ENDIAN
#
#  elif defined(_MRX0000)   /* I wonder if someone is still using it ? */
#
#    define  M_CPU  M_CPU_MIPS
#    define  M_CONFIG_HAS_ENDIANESS
#    define  M_CONFIG_BIG_ENDIAN
#
#  endif


/* do we have an inline keyword ? */
#  define  M_CONFIG_HAS_INLINE
#  define  M_INLINE  inline

/* do we have a 64-bits integer ? */
#  define  M_CONFIG_HAS_INT64
#  define  M_INT64_T        __int64
#  define  M_INT64_FMT_0    "I64"

/* DLL import/export macros */
#  define  M_DLL_IMPORT(x)          __declc(dllimport)  x
#  define  M_DLL_EXPORT(x)          x
#  define  M_DLL_EXPORT_LAZY(x)     __declc(dllexport)  x

/* do we have function names available ? */
#  define  M__FUNCTION__    __FUNC__

#endif /* _MSC_VER */

#endif /* __MLIB_COMPILER_VISUAL_CPP_H__ */

