/*****************************************************************************
 *
 *  MLib platform-specific configuration file
 *
 *    detection directives for the Watcom C/C++ compiler
 *
 *  this file is used to compute platform-specific configuration macros,
 *  based on the current compiler setup.
 *
 *  note that we cannot use run-time checks on the host machine to
 *  determine the target endianess.
 *
 *  All configuration macros are _optional_, i.e. they're not required
 *  to compile the MLib. However, certain features or the library will
 *  not be compiled when some "features" are missing
 *
 *  for a list of macros, see the file MLIB_COMPILATION_OPTIONS
 *
 *****************************************************************************/

#ifndef __MLIB_COMPILER_WATCOM_H__
#define __MLIB_COMPILER_WATCOM_H__

/* determine endianess - for now, be really simple !! */

#ifdef __WATCOMC__

/* Watcom only compiles on x86 */
#  define M_CONFIG_HAS_ENDIANESS
#  define M_CONFIG_LITTLE_ENDIAN

/* do we have an inline keyword ? */
#  define  M_CONFIG_HAS_INLINE
#  define  M_INLINE  inline

/* do we have a 64-bits integer ? */
#  undef   M_CONFIG_HAS_INT64

/* DLL import/export macros */
#  ifdef __WINDOWS_386__
#    define  M_DLL_IMPORT(x)          __pascal x
#    define  M_DLL_EXPORT(x)          __pascal __export  x
#    define  M_DLL_EXPORT_LAZY(x)     __pascal __export  x
#  endif /* __WINDOWS_386__ */

/* we're on a x86 cpu, we need more test to determine the OS */
#  define  M_CPU        M_CPU_X86


#endif /* __WATCOMC__ */

#endif /* __MLIB_COMPILER_WATCOM_H__ */

