#ifndef __MLIB_INTERNAL_OBJECT_G__
#define __MLIB_INTERNAL_OBJECT_G__

#include <mlib/internal/iobject.h>

/* generic definitions for meta-class hash table           */
/* it is organized as follows:                             */
/*                                                         */
/*   hash nodes are the M_Class objects themselves         */
/*                                                         */
/*   the 'info' field of each M_Class is used as a hash    */
/*   link                                                  */
/*                                                         */
/*   the 'type' field of each M_Class is used as a hash    */
/*   key (since it's a constant pointer)                   */
/*                                                         */
/*                                                         */

#define  GEN_TABLE                 M_MetaClass
#define  GEN_TABLE_PREFIX          m_meta_class
#define  GEN_TABLE_MEMORY(meta)    M_CLASS(meta)->memory

#define  GEN_HASH_SIZE(meta)   (meta)->size
#define  GEN_HASH_COUNT(meta)  (meta)->count

/* nodes are M_Class objects */
#define  GEN_NODE                M_Class
#define  GEN_NODE_LINK(c)        M_CLASS((c)->info)
#define  GEN_NODE_LINK_ADDR(c)  ((M_Class*)(&(c)->info))
#define  GEN_NODE_KEY(c)         (c)->type
#define  GEN_NODE_HASH(c)        M_CLASS_HASH(c)
#define  GEN_NODE_VALUE(c)       (c)

#define  GEN_NODE_SET(c,key,val,meta)   M_DUMMY_STMNT
#define  GEN_NODE_UNSET(c,meta)         M_DUMMY_STMNT

#define  GEN_NODE_DESTROY(c,meta)  \
             m_class_destroy(c)

#define  GEN_NODE_NEW(c,key,value,meta)  \
             c = m_class_create( meta, key )

/* keys are constant M_ClassType pointers */
#define  GEN_KEY                     M_ClassType
#define  GEN_KEY_HASH(key,meta)      M_POINTER_TO_DIST(key)
#define  GEN_KEY_COMPARE(key,meta)   NULL
#define  GEN_KEY_DATA(key,meta)      NULL

/* values are M_Class objects themselves */
#define  GEN_VALUE                   M_ClassRec*

/* by default, defines static functions */

#endif /* __MLIB_INTERNAL_HASH_G__ */
