#ifndef __MLIB_INTERNAL_DATE_H__
#define __MLIB_INTERNAL_DATE_H__

#include <mlib/date.h>

M_BEGIN_HEADER

 /* for more information about these computations, please */
 /* see the Calendar FAQ                                  */


  typedef struct M_IDateRec_
  {
    M_UInt32   julian;   /* julian day in gergorian calendar */
    M_Int16    year;
    M_Byte     month;
    M_Byte     day;
    M_Byte     flags;

  } M_IDateRec, *M_IDate;

#define  M_IDATE(x)  ((M_IDate)(x))

#define  M_DATE_FLAG_VALID    1
#define  M_DATE_FLAG_CHECKED  2
#define  M_DATE_FLAG_JULIAN   4
#define  M_DATE_FLAG_DMY      8

#define  M_DATE_IS_VALID(_date)                              \
             ( ((_date)->flags & M_DATE_FLAG_CHECKED)        \
             ? (((_date)->flags & M_DATE_FLAG_VALID) != 0)   \
             : m_idate_check(_date) )

#define  M_DATE_NEED_DMY(_date)                         \
           M_BEGIN_STMNT                                \
             if (!((_date)->flags & M_DATE_FLAG_DMY))   \
               m_idate_to_dmy(_date);                   \
           M_END_STMNT

#define  M_DATE_NEED_JULIAN(_date)                         \
           M_BEGIN_STMNT                                   \
             if (!((_date)->flags & M_DATE_FLAG_JULIAN))   \
               m_idate_to_julian(_date);                   \
           M_END_STMNT



  MLIB_VAR( const M_Int )  m_date_month_days[];

  MLIB_LOCAL(M_Int)
  m_date_days_in_month( M_DateMonth  month,
                        M_DateYear   year );

  MLIB_LOCAL(void)
  m_idate_to_julian( M_IDate  date );


  MLIB_LOCAL(void)
  m_idate_to_dmy( M_IDate  date );


  MLIB_LOCAL( M_Bool )
  m_idate_check( M_IDate  date );


M_END_HEADER

#endif /* __MLIB_INTERNAL_DATE_H__ */
