#ifndef __MLIB_INTERNAL_OBJECT_H__
#define __MLIB_INTERNAL_OBJECT_H__

#include <mlib/object.h>

M_BEGIN_HEADER

#define   M_MAGIC_CLASS       0x63676173  /* "clas" */

#define   M_MAGIC_META_CLASS  0x63676170  /* "clap" */
#define   M_META_CLASS_ID     M_MAGIC_META_CLASS


 /* the meta-class provides a (class_type => class) dictionary */
 /* by implementing a small specialized hash table..           */
 /*                                                            */
  typedef struct M_MetaClassRec_
  {
    M_ClassRec    clazz;
    M_UInt32      magic;
    M_Lock        lock;
    M_UInt        size;
    M_UInt        count;
    M_Class*      buckets;

  } M_MetaClassRec, *M_MetaClass;

#define  M_CLASS_HASH(c)  ((M_ULong)(M_POINTER_TO_DIST((c)->type)))


#define  m_assert_is_meta_class(x)   \
            m_assert( (x) && (x)->magic == M_MAGIC_META_CLASS )


M_END_HEADER

#endif /* __MLIB_INTERNAL_OBJECT_H__ */
