#ifndef __MLIB_INTERNAL_ROPE_H__
#define __MLIB_INTERNAL_ROPE_H__

#include <mlib/rope.h>

M_BEGIN_HEADER

 /* internal rope definition */
  typedef struct M_IRopeRec_
  {
    M_RopeRec   root;
    M_Size      capacity;
    M_Memory    memory;

  } M_IRopeRec, *M_IRope;

#define  M_IROPE(x)  ((M_IRope)(x))

  MLIB_LOCALDEF(M_Rope)
  m_rope_new_bound0( M_Memory   memory,
                     M_CString  init,
                     M_Size     len,
                     M_Bool     push );

  MLIB_LOCAL(void)
  m_rope_append0( M_Rope     target,
                  M_CString  source,
                  M_Size     len );

  MLIB_LOCAL(void)
  m_rope_prepend0( M_Rope     target,
                   M_CString  source,
                   M_Size     len );

  MLIB_LOCAL( void )
  m_rope_insert0( M_Rope     target,
                  M_Int      pos,
                  M_CString  source,
                  M_Size     len );

M_END_HEADER

#endif /* __MLIB_ROPE_H__ */
