#ifndef __MLIB_INTERNAL_STREAM_H__
#define __MLIB_INTERNAL_STREAM_H__

#include <mlib/stream.h>
#include <mlib/ring.h>

M_BEGIN_HEADER

/* indicates that a frame was alloced in the heap */
#define  M_FRAME_ALLOC   16

  typedef struct M_FrameInfoRec_*  M_FrameInfo;

  typedef struct M_FrameInfoRec_
  {
    M_Frame      bytes;
    M_Size       size;
    M_FrameInfo  link;   /* next frame in list */

  } M_FrameInfoRec;


  typedef struct M_StreamInfoRec_
  {
    M_UInt          flags;      /* see M_StreamFlags      */
    M_Buffer        buffer;     /* optional buffer handle */
    M_Stream        parent;     /* used on method calls   */
    M_FrameInfo     frames;     /* list of opened frames  */

  } M_StreamInfoRec;


  typedef struct M_AnsiStreamRec_*     M_AnsiStream;

  typedef struct M_AnsiStreamRec_
  {
    M_StreamRec  stream;
    FILE*        file;

  } M_AnsiStreamRec;


  MLIB_VAR( M_Stream_Class )   m_ansi_stream_class;

 /* switch stream to read mode */
  MLIB_LOCAL( void )  m_stream_to_read ( M_Stream  stream );

 /* switch stream to write mode */
  MLIB_LOCAL( void )  m_stream_to_write( M_Stream  stream );

M_END_HEADER

#endif /* __MLIB_INTERNAL_STREAM_H__ */
