#ifndef __MLIB_INTERNAL_TIME_H__
#define __MLIB_INTERNAL_TIME_H__

#include <mlib/time.h>

M_BEGIN_HEADER

#define  M_USEC_PER_SEC   (1024*1024)  /* don't change that !! */


 /* we store the number of "micro" seconds since Jan 1, 1970 here */
 /* as a 64-bit signed integer..                                  */
 /*                                                               */
 /* it's up to platform-specific code to populate these fields    */
 /* appropriately..                                               */
 /*                                                               */
 typedef M_Calc64   M_ITime;

#define  M_ITIME(x)    ((M_ITime)(x))
#define  M_ITIME_P(x)  ((M_ITime*)(x))

  MLIB_LOCAL(void)
  m_itime_get_date( M_Time        time_,
                    M_DateDay    *pday,
                    M_DateMonth  *pmonth,
                    M_DateYear   *pyear,
                    M_Int32      *pseconds );

  MLIB_LOCAL(void)
  m_itime_get_dmy( M_ITime       time,
                   M_DateDay    *aday,
                   M_DateMonth  *amonth,
                   M_DateYear   *ayear,
                   M_Int32      *pseconds,
                   M_Int32      *pusec );

M_END_HEADER

#endif /* __MLIB_INTERNAL_TIME_H__ */
