#ifndef __MLIB_INTERNAL_TREE_H__
#define __MLIB_INTERNAL_TREE_H__

#include <mlib/tree.h>

M_BEGIN_HEADER

#define  M_TREE_MAGIC         0x74726565  /* "tree" */

 /* handle to tree node */
  typedef struct M_TreeNodeRec_*   M_TreeNode;

  typedef struct M_TreeNodeRec_
  {
    M_TreeNode    links[2];
    M_Byte        cache;
    M_Int8        balance;
    M_Pointer     key;
    M_Pointer     value;

  } M_TreeNodeRec;


  typedef struct M_TreeRec_
  {
    M_Memory            memory;
    M_Memory            node_pool;
    M_UInt32            magic;
    M_ULong             size;
    M_TreeNode          root;

    M_CompareDataFunc   key_compare;
    M_DestroyDataFunc   key_destroy;
    M_Pointer           key_data;

    M_DestroyDataFunc   val_destroy;
    M_Pointer           val_data;

  } M_TreeRec;



#define  m_assert_is_tree(x)    \
            m_assert( (x) && (x)->magic == M_TREE_MAGIC )

  MLIB_LOCAL(void)
  m_tree_clear( M_Tree  tree );

M_END_HEADER

#endif /* __MLIB_INTERNAL_TREE_H__ */

