/*
 *  you should include this file each time you need to define a unit test
 *  within the MLib.
 *
 *  you need to define two macros before doing so though:
 *
 *    M_TEST_FUNCTION :: the test function identifier
 *    M_TEST_NAME     :: a string used to name the test
 *
 *  you can also optional define the following macro:
 *
 *    M_TEST_SIZE     :: the size in bytes of the test object
 *
 *  if undefined, this will default to "sizeof(M_TestRec)"
 *
 *  these macros are automatically #undefined at the end of this file
 *
 *  The following source is used to build at _compile_ time a linked
 *  list of "registered" test classes.
 */

#ifndef M_TEST_FUNCTION
#define  M_TEST_FUNCTION not defined in new test definition
#endif

#ifndef M_TEST_NAME
#define  M_TEST_NAME not defined in new test definition
#endif

#ifndef M_TEST_SIZE
#define M_TEST_SIZE  sizeof( M_TestRec )
#endif

  const M_Test_ClassRec   M_CONCAT( M_TEST_FUNCTION, _class ) =
  {
    M_TEST_NAME,
    M_TEST_SIZE,
    (M_Test_RunFunc) M_TEST_FUNCTION
  };

#undef M_TEST_SIZE
#undef M_TEST_NAME
#undef M_TEST_FUNCTION
