#include <mlib/internal/ibitset.h>

  MLIB_APIDEF(void)
  m_bitset_clear( M_Bitset  bitset )
  {
    if (bitset)
    {
      M_Memory  memory  = bitset->memory;
      M_UInt**  pblock  = bitset->blocks;
      M_UInt*   block;
      M_UInt    count   = bitset->block_count;

      m_assert( memory );

      for ( ; count > 0; count--, pblock++ )
      {
        block = pblock[0];
        if ( !M_BITSET_IS_ALL(block) )
          m_bitset_block_destroy( bitset, block );
        pblock[0] = 0;
      }

      M_FREE( bitset->blocks );
      bitset->block_count = 0;
    }
  }


