#include <mlib/internal/ibitset.h>

  MLIB_APIDEF(void)
  m_bitset_compress( M_Bitset  set )
  {
    if ( set && set->blocks )
    {
      M_UInt    count       = set->block_count;
      M_UInt**  pblock;

      m_assert( count > 0 );

      /* first of all, get rid of block that are filled with 8-bit patterns */
      for ( pblock = set->blocks; count > 0; count--, pblock++ )
      {
        M_UInt   count2 = M_BITSET_BLOCK_COUNT;
        M_UInt*  block  = pblock[0];

        if ( !M_BITSET_IS_ALL(block) )
        {
          M_UInt  search;

          search = block[0];
          if ( m_bitset_is_pattern( search ) )
          {
            for ( ; count2 > 0; count2--, block++ )
              if ( block[0] != search )
                goto Skip;

            m_bitset_block_destroy( set, pblock[0] );
            pblock[0] = M_BITSET_ALL_NUM( (M_Byte)search );
          }
        }
      Skip:
        ;
      }

      /* now, get rid of last blocks that are all clear */
      {
        M_UInt  new_count = set->block_count;

        count  = new_count;
        pblock = set->blocks + new_count - 1;
        for ( ; count > 0; count--, pblock--, new_count-- )
          if ( pblock[0] != M_BITSET_ALL_ZERO )
            break;

        if ( new_count < set->block_count )
        {
          M_Memory  memory = set->memory;
          M_RENEW_ARRAY( set->blocks, set->block_count, new_count );
          set->block_count = new_count;
        }
      }
    }
  }


