#include <mlib/internal/ibitset.h>

  MLIB_APIDEF(M_Bitset)
  m_bitset_copy( M_Bitset  source,
                 M_Bool    push )
  {
    M_Bitset  result = 0;

    if ( source )
    {
      M_Memory  memory;
      M_UInt    count;
      M_UInt**  pblock1;
      M_UInt**  pblock;

      m_assert_is_bitset( source );

      count   = source->block_count;
      pblock1 = source->blocks;
      memory  = source->memory;

      M_NEW( result );

      result->memory     = memory;
      result->magic      = M_BITSET_MAGIC;
      result->block_pool = source->block_pool;

      m_bitset_push( result );

      m_bitset_ensure( result, count * M_BITSET_BLOCK_LEN );

      pblock = result->blocks;
      for ( ; count > 0; count--, pblock++, pblock1++ )
        pblock[0] = m_bitset_block_copy( result, pblock1[0] );

      if (!push)
        m_bitset_pop( result, TRUE );
    }
    return result;
  }



