#include <mlib/internal/ibitset.h>

  MLIB_APIDEF(M_Bitset)
  m_bitset_intersect( M_Bitset  set1,
                      M_Bitset  set2,
                      M_Bool    push )
  {
    M_UInt    count, **pblock1, **pblock2, **pblock;
    M_Bitset  bitset;

    if ( !set1 || !set2 )
      return 0;

    bitset = m_bitset_new( set1->memory, 1 );
    count  = M_MIN( set1->block_count, set2->block_count );

    m_bitset_ensure( bitset, count * M_BITSET_BLOCK_LEN );

    pblock1 = set1->blocks;
    pblock2 = set2->blocks;
    pblock  = bitset->blocks;

    for ( ; count > 0; count--, pblock1++, pblock2++, pblock++ )
    {
      M_UInt   count2 = M_BITSET_BLOCK_COUNT;
      M_UInt*  block1 = pblock1[0];
      M_UInt*  block2 = pblock2[0];
      M_UInt*  block;
      M_UInt   val1, val2;

      if ( M_BITSET_IS_ALL(block1) )
      {
        val1 = M_BITSET_ALL_VAL(block1);
        if (!val1)
        {
          block = M_BITSET_ALL_ZERO;
        }
        else if ( M_BITSET_IS_ALL(block2))
        {
          val2  = M_BITSET_ALL_VAL(block2);
          block = M_BITSET_ALL_NUM( val1 & val2 );
        }
        else
        {
          M_UInt*  p;

          block = p = m_bitset_block_new( bitset );
          for ( ; count2 > 0; count2--, p++, block2++ )
            p[0] = ( val1 & block2[0] );
        }
      }
      else if ( M_BITSET_IS_ALL(block2) )
      {
        val2 = M_BITSET_ALL_VAL(block2);
        if (!val2)
        {
          block = M_BITSET_ALL_ZERO;
        }
        else
        {
          M_UInt*  p;

          block = p = m_bitset_block_new( bitset );
          for ( ; count2 > 0; count2--, p++, block1++ )
            p[0] = ( block1[0] & val2 );
        }
      }
      else
      {
        M_UInt*  p;

        block = p = m_bitset_block_new( bitset );
        for ( ; count2 > 0; count2--, p++, block1++, block2++ )
          p[0] = ( block1[0] & block2[0] );
      }
      pblock[0] = block;
    }

    m_bitset_compress( bitset );
    if (!push)
      m_bitset_pop( bitset, TRUE );

    return bitset;
  }


