#include <mlib/internal/ibitset.h>

  MLIB_APIDEF(M_Int)
  m_bitset_last( M_Bitset  bitset )
  {
    if ( bitset && bitset->blocks )
    {
      M_UInt    count  = bitset->block_count;
      M_Int     base   = M_BITSET_BLOCK_LEN * count;
      M_UInt**  pblock = bitset->blocks + count - 1;

      m_assert( count > 0 );
      for ( ; count > 0; count--, pblock-- )
      {
        M_UInt*  block  = pblock[0];
        M_UInt   count2 = M_BITSET_BLOCK_COUNT;

        if ( block == M_BITSET_ALL_ZERO )
        {
          base -= M_BITSET_BLOCK_LEN;
        }
        else if ( M_BITSET_IS_ALL(block) )
        {
          return base - M_BITSET_BLOCK_BITS +
                 m_bits32_highest( M_BITSET_ALL_VAL(block) );
        }
        else
        {
          block += M_BITSET_BLOCK_COUNT-1;
          do
          {
            block--;
            base -= M_BITSET_BLOCK_BITS;

            if (block[0])
              return base + m_bits32_highest( block[0] );

            count2--;
          }
          while (count2 > 0);
        }
      }
    }
    return -1;
  }

