#include <mlib/internal/ibitset.h>

  MLIB_APIDEF(M_Bitset)
  m_bitset_new( M_Memory  memory,
                M_Bool    push )
  {
    M_Bitset   bitset;
    M_Memory   pool;

    m_assert_is_memory( memory );

    pool   = m_memory_pool_find( memory, M_BITSET_BLOCK_BYTES );
    M_NEW( bitset );

    bitset->memory      = memory;
    bitset->magic       = M_BITSET_MAGIC;
    bitset->block_pool  = pool;
    bitset->block_count = 0;
    bitset->blocks      = 0;

    if (push)
      m_bitset_push( bitset );

    return bitset;
  }


