#include <mlib/internal/ibitset.h>

  MLIB_LOCALDEF(M_UInt**)
  m_bitset_set_prepare( M_Bitset  bitset,
                        M_UInt    index,
                        M_UInt    size,
                        M_UInt    value )
  {
    M_UInt  *block, **pblock;

    if ( index + size > bitset->block_count * M_BITSET_BLOCK_LEN )
    {
      /* nothing to do if value is 0 */
      if (!value) return 0;
      m_bitset_ensure( bitset, index + size );
    }

    pblock = bitset->blocks + index / M_BITSET_BLOCK_LEN;
    block  = pblock[0];
    if ( M_BITSET_IS_ALL(block) )
    {
      M_UInt  val = M_BITSET_ALL_VAL(block);
      M_UInt  val2;

      val2 = (val >> ( index % M_BITSET_BLOCK_BITS )) & ((1L << size) - 1);

      /* nothing to do if storing same value */
      if ( val2 == value )
        return 0;

      /* otherwise, create block */
      pblock[0] = block = m_bitset_block_new( bitset );
      M_MEM_SET( block, (M_Byte)val, M_BITSET_BLOCK_BYTES );
    }
    return pblock;
  }


