#include <mlib/internal/ibitset.h>

  MLIB_APIDEF(M_Bool)
  m_bitset_test_intersect( M_Bitset  set1,
                           M_Bitset  set2 )
  {
    if ( set1 && set2 )
    {
      M_UInt    count, **pblock1, **pblock2, *block1, *block2;

      count   = M_MIN( set1->block_count, set2->block_count );
      pblock1 = set1->blocks;
      pblock2 = set2->blocks;

      for ( ; count > 0; count--, pblock1++, pblock2++ )
      {
        M_UInt  count2 = M_BITSET_BLOCK_COUNT;
        M_UInt  val1, val2;

        block1 = pblock1[0];
        block2 = pblock2[0];

        if ( M_BITSET_IS_ALL(block1) )
        {
          val1 = M_BITSET_ALL_VAL(block1);
          if (!val1) continue;

          if ( M_BITSET_IS_ALL(block2) )
          {
            val2 = M_BITSET_ALL_VAL(block2);
            if ( val1 & val2 )
              goto Yes;
          }
          else
          {
            for ( ; count2 > 0; count2--, block2++ )
              if ( val1 & block2[0] )
                goto Yes;
          }
        }
        else if ( M_BITSET_IS_ALL(block2) )
        {
          val2 = M_BITSET_ALL_VAL(block2);
          if (!val2) continue;

          for ( ; count2 > 0; count2--, block1++ )
            if ( block1[0] & val2 )
              goto Yes;
        }
        else
        {
          for ( ; count2 > 0; count2--, block1++, block2++ )
            if ( block1[0] & block2[0] )
              goto Yes;
        }
      }
    }
    return 0;
  Yes:
    return 1;
  }


