#include <mlib/buffer.h>

 /* a feed function for fixed-block buffers. we simply update */
 /* 'buffer->base' in this case, since we do not need to      */
 /* change the content of the memory block during feeds..     */
 /*                                                           */
  static M_Size
  m_buffer_fixed_feed( M_Buffer  buffer,
                       M_Size    wanted )
  {
    /* ignore this */
    M_UNUSED( wanted );

    /* adjust base position */
    buffer->pos += (M_Size)( buffer->cur - buffer->base );

    /* adjust base */
    buffer->base = buffer->cur;

    /* return available size */
    return (M_Size)( buffer->limit - buffer->cur );
  }


  MLIB_APIDEF( void )
  m_buffer_init_fixed( M_Buffer   buffer,
                       M_ByteP    address,
                       M_Size     size )
  {
    M_ZERO( buffer );
    buffer->base  = address;
    buffer->cur   = address;
    buffer->limit = address + size;
    buffer->feed  = m_buffer_fixed_feed;
  }

