#include <mlib/buffer.h>

  MLIB_APIDEF( M_ByteP )
  m_buffer_peek( M_Buffer  buffer,
                 M_Size    size )
  {
    M_ByteP  result;
    M_Size   avail;

    result = buffer->cur;
    avail  = (M_Size)( buffer->limit - buffer->cur );

    /* first, check if we can directly peek in the buffer */
    if ( size <= avail )
    {
      buffer->cur += size;
      return result;
    }

    /* otherwise, can we feed it ?? */
    avail = buffer->feed( buffer, size );
    if ( size <= avail )
    {
      result       = buffer->cur;
      buffer->cur += size;
      return result;
    }

    return NULL;
  }



