#include <mlib/buffer.h>

  MLIB_APIDEF( M_Size )
  m_buffer_read( M_Buffer  buffer,
                 M_ByteP   dest,
                 M_Size    size )
  {
    M_ByteP  d = dest;

    m_assert_is_buffer( buffer );

    if ( size == 0 )
      return 0;

    m_assert( dest );

    for (;;)
    {
      M_Size  len, avail;

      avail = (M_Size)( buffer->limit - buffer->cur );
      len   = M_MIN( size, avail );
      if ( len > 0 )
      {
        M_MEM_COPY( d, buffer->cur, len );
        buffer->cur += len;
        d           += len;
        size        -= len;

        if ( size == 0 )
          break;
      }

      avail = buffer->feed( buffer, size );
      if ( avail == 0 )
        break;
    }
    return (M_Size)( d - dest );
  }


