#include <mlib/buffer.h>


  MLIB_APIDEF( M_Size )
  m_buffer_skip( M_Buffer  buffer,
                 M_Size    size )
  {
    M_Size  result = 0;

    m_assert_is_buffer( buffer );

    for (;;)
    {
      M_Size  len, avail;

      avail = (M_Size)( buffer->limit - buffer->cur );
      len   = M_MIN( size, avail );
      if ( len > 0 )
      {
        buffer->cur += len;
        result      += len;
        size        -= len;

        if ( size == 0 )
          break;
      }

      avail = buffer->feed( buffer, size );
      if ( avail == 0 )
        break;
    }
    return result;
  }



