#include <mlib/buffer.h>

  MLIB_APIDEF( M_Size )
  m_buffer_write( M_Buffer  buffer,
                  M_CByteP  src,
                  M_Size    size )
  {
    M_CByteP  s = src;

    m_assert_is_buffer( buffer );

    if ( size == 0 )
      return 0;

    m_assert( src );

    for ( ;; )
    {
      M_Size  len, avail;

      avail = (M_Size)( buffer->limit - buffer->cur );
      len   = M_MIN( size, avail );
      if ( len > 0 )
      {
        M_MEM_COPY( buffer->cur, s, len );
        buffer->cur += len;
        s           += len;
        size        -= len;

        if ( size == 0 )
          break;
      }

      avail = buffer->feed( buffer, size );
      if ( avail == 0 )
        break;
    }
    return (M_Size)( s - src );
  }



