#include <mlib/internal/icalc.h>

  MLIB_API( void )
  m_calc64_sar( M_Calc64  z,
                M_Int     shift )
  {
    if ( (M_UInt)shift < 32 )
    {
      M_Card64  z_ = M_CARD64(z);

      /* most common case */
      M_SAR64( z_->hi, z_->lo, shift );
    }
    else
    {
      if ( shift > 0 )
      {
        M_Int32  hi = z->hi;

        z->hi = hi >> 31;  /* preserve sign */
        z->lo = ( shift < 64 ) ? M_UINT32( hi >> (shift-32) ) : z->hi;
      }
      else
        m_calc64_shl( z, -shift );
    }
  }


