#include <mlib/internal/icalc.h>


#ifdef M_CONFIG_HAS_INT64

  MLIB_APIDEF(M_Fix16)
  m_fix16_muldiv( M_Fix16   a,
                  M_Fix16   b,
                  M_Fix16   c )
  {
    M_Fix16  s;
    M_Int64  val;

    s = a^b^c;
    if (a < 0) a = -a;
    if (b < 0) b = -b;
    if (c < 0) c = -c;

    val = (M_Int64)a * b;
    if ( val >= (M_INT64(c) << 32) )
      val = M_FIX16_MAX;
    else
      val /= c;

    return M_FIX16( s >= 0 ? val : -val );
  }

#else /* !M_CONFIG_HAS_INT64 */

  MLIB_APIDEF(M_Fix16)
  m_fix16_muldiv( M_Fix16  a,
                  M_Fix16  b,
                  M_Fix16  c )
  {
    return m_imuldiv( a, b, c );
  }

#endif /* !M_CONFIG_HAS_INT64 */
