#include <mlib/calc.h>

#ifdef M_CONFIG_HAS_INT64

  MLIB_APIDEF( M_Int32  )
  m_imuldiv_round( M_Int32   a,
                   M_Int32   b,
                   M_Int32   c )
  {
    M_Int32  s, r;

    s  = a;  if ( a < 0 ) a = -a;
    s ^= b;  if ( b < 0 ) b = -b;
    s ^= c;  if ( c < 0 ) c = -c;

    r = M_INT32_MAX;
    if ( c > 0 )
    {
      M_Int64  z = (M_INT64(a)*b + (c >> 1)) / c;

      if ( z <= M_INT32_MAX )
        r = M_INT32(z);
    }

    return ( s >= 0 ) ? r : -r;
  }

#else /* !M_CONFIG_HAS_INT64 */

  MLIB_APIDEF( M_Int32  )
  m_imuldiv_round( M_Int32   a,
                   M_Int32   b,
                   M_Int32   c )
  {
    M_Int32  s, r;

    s  = a;  if ( a < 0 ) a = -a;
    s ^= b;  if ( b < 0 ) b = -b;
    s ^= c;  if ( c < 0 ) c = -c;

    r = M_INT32_MAX;
    if ( c > 0 )
    {
      M_Card64Rec  z;

      m_card64_umul( &z, M_UINT32(a), M_UINT32(b) );
      m_card64_add ( &z, 0, M_UINT32(c >> 1) );

      r2 = m_calc64_udiv( &z, M_UINT32(c) );

      if ( r2 <= M_INT32_MAX )
        r = r2;
    }

    return ( s >= 0 ) ? r : -r;
  }

#endif /* !M_CONFIG_HAS_INT64 */
