#include <mlib/calc.h>

#ifdef M_CONFIG_HAS_INT64

  MLIB_APIDEF( M_UInt32 )
  m_umuldiv_round( M_UInt32  a,
                   M_UInt32  b,
                   M_UInt32  c )
  {
    M_UInt64  z;

    if ( c == 0 )
      return M_UINT32_MAX;

    z = ((M_UInt64)a*b + (c/2)) / c;

    return ( z > M_UINT32_MAX )
           ? M_UINT32_MAX
           : M_UINT32(z);
  }

#else /* !M_CONFIG_HAS_INT64 */

  MLIB_APIDEF( M_UInt32 )
  m_umuldiv_round( M_UInt32  a,
                   M_UInt32  b,
                   M_UInt32  c )
  {
    M_Calc64Rec  z;

    if ( c == 0 )
      return M_UINT32_MAX;

    m_card64_mul( &z, a, b );
    m_card64_add( &z, 0, c >> 1 );

    return m_card64_div( &z, c );
  }

#endif /* !M_CONFIG_HAS_INT64 */
