#include <mlib/version.h>

  MLIB_APIDEF( M_Int )
  m_version_compare( M_Version  v1,
                     M_Version  v2 )
  {
    M_Int  result;
    
    result = M_COMPARE( v1->major, v2->major );
    if ( result == 0 )
    {
      result = M_COMPARE( v1->minor, v2->minor );
      if ( result == 0 )
        result = M_COMPARE( v1->patch, v2->patch );
    }
    
    return result;
  }


  MLIB_APIDEF( M_Bool )
  m_version_equal( M_Version  v1,
                   M_Version  v2 )
  {
    return ( v1->major == v2->major &&
             v1->minor == v2->minor &&
             v1->patch == v2->patch );
  }                   


  MLIB_APIDEF( M_Bool )
  m_version_check_source( M_Version  v1,
                          M_Version  v2 )
  {
    return  ( v1->major == v2->major &&
              v1->minor == v2->minor );
  }                          



  MLIB_APIDEF( M_Bool )
  m_version_check_binary( M_Version  v1,
                          M_Version  v2 )
  {
    M_Bool  result;
    
    result = ( v1->major == v2->major );
    if ( result )
      result = ( v1->major <= v2->major );
      
    return result;
  }                          



  MLIB_APIDEF( void )
  mlib_get_version( M_Version  version )
  {
    version->major = MLIB_VERSION_MAJOR;
    version->minor = MLIB_VERSION_MINOR;
    version->patch = MLIB_VERSION_PATCH;
  }


  MLIB_APIDEF( M_CString )
  mlib_get_version_string( void )
  {
    return MLIB_VERSION_STRING;
  }
