#include <mlib/internal/idate.h>

  MLIB_LOCALDEF( M_Bool )
  m_idate_check( M_IDate  date )
  {
    M_Bool  result = 0;
    M_UInt  flags  = date->flags;

    /* check year */
    if ( flags & M_DATE_FLAG_DMY )
    do
    {
      M_Int  year  = date->year;
      M_Int  month = date->month;
      M_Int  day   = date->day;
      M_Int  days_in_month;

      result = FALSE;

      /* check year */
      if ( year < 1 )
        break;

      /* check month */
      if ( month < 1 || month > 12 )
        break;

      days_in_month = m_date_days_in_month( month, year );

      /* check day */
      if ( day < 1 || day > days_in_month )
        break;

      result = TRUE;
    }
    while (0);


    if ( flags & M_DATE_FLAG_JULIAN )
    do
    {
      result = FALSE;
      if ( date->julian < 1 )
        break;

      result = TRUE;
    }
    while (0);


    if ( result )
      flags  = M_DATE_FLAG_VALID;
    else
      flags &= ~M_DATE_FLAG_VALID;

    date->flags = (M_Byte)( flags | M_DATE_FLAG_CHECKED );
    return result;
  }


