#include <mlib/internal/ihash.h>

 /* destroy a given hash node */
  MLIB_LOCALDEF(void)
  m_hash_node_destroy( M_HashNode   node,
                       M_HashTable  table )
  {
    if (node)
    {
      m_assert_is_hash_table( table );

      node->link = 0;

      if ( node->key && table->key_destroy )
        table->key_destroy( node->key, table->key_data );

      if ( node->value && table->val_destroy )
        table->val_destroy( node->value, table->val_data );

      node->key   = 0;
      node->hash  = 0;
      node->value = 0;
      m_mem_free( node, table->node_pool );
    }
  }

