#include <mlib/internal/ihash.h>


  MLIB_API(M_HashTable)
  m_hash_table_new_full( M_Memory            memory,
                         M_HashDataFunc      key_hash,
                         M_CompareDataFunc   key_compare,
                         M_DestroyDataFunc   key_destroy,
                         M_Pointer           key_data,
                         M_DestroyDataFunc   val_destroy,
                         M_Pointer           val_data )
  {
    M_HashTable  table;

    m_assert_is_memory( memory );

    M_NEW_PUSH( table );

    table->memory    = memory;
    table->node_pool = m_memory_pool_find( memory, sizeof( M_HashNodeRec ) );
    table->magic     = M_HASH_TABLE_MAGIC;
    table->size      = M_PRIMES_MIN;
    table->nodes     = 0;

    table->key_hash    = key_hash;
    table->key_compare = key_compare;
    table->key_destroy = key_destroy;
    table->key_data    = key_data;

    table->val_destroy = val_destroy;
    table->val_data    = val_data;

    M_NEW_ARRAY( table->buckets, table->size );

    M_MEM_POP( table );

    return table;
  }


