#include <mlib/internal/ilhash.h>

MLIB_APIDEF( void )
m_lhash_add( M_LHash     table,
             M_LHLookup  lookup,
             M_LHNode    new_node )
{
  M_LHNode  node, *pnode;

  /* add new node to the hash table */
  new_node->link = *lookup;
  *lookup        = new_node;

  /* split one bucket when necessary */
  if ( --table->slack < 0 )
  {
    M_UInt    p    = table->p;
    M_UInt    mask = table->mask;
    M_LHNode  list = NULL;

    pnode = lookup = table->buckets + p;
    for (;;)
    {
      node = *pnode;
      if ( node == NULL )
        break;

      if ( node->hash & (mask+1) )
      {
        *pnode     = node->link;
        node->link = list;
        list       = node;
      }
      else
        pnode = &node->link;
    }

    table->buckets[ p + mask + 1 ] = list;

    table->slack += M_LHASH_MAX_LOAD;

    if ( p >= mask )
    {
      M_Memory  memory = table->memory;

      M_RENEW_ARRAY( table->buckets, (mask+1)*2, (mask+1)*4 );
      table->mask = 2*mask + 1;
      table->p    = 0;
    }
    else
      table->p = p + 1;
  }
}
