#include <mlib/internal/ilhash.h>

MLIB_APIDEF( void )
m_lhash_done_full( M_LHash            table,
                   M_DestroyDataFunc  node_destroy,
                   M_CPointer         node_data )
{
  if ( table && table->memory )
  {
    M_Memory  memory = table->memory;

    if ( node_destroy )
    {
      /* parse all nodes for destruction */

      M_UInt     count  = table->p + table->mask + 1;
      M_LHNode*  bucket = table->buckets;

      for ( ; count > 0; count--, bucket++ )
      {
        M_LHNode  node, next;

        node = *bucket;
        while ( node )
        {
          next = node->link;
          node_destroy( node, node_data );
          node = next;
        }
        *bucket = NULL;
      }
    }

    M_FREE( table->buckets );

    table->p      = 0;
    table->mask   = 0;
    table->slack  = 0;

    table->node_equal = NULL;
    table->node_data  = NULL;

    table->memory = NULL;
  }
}
