#include <mlib/internal/ilhash.h>

MLIB_APIDEF( M_LHLookup )
m_lhash_lookup( M_LHash   table,
                M_LHNode  key_node )
{
  M_UInt32         hash = key_node->hash;
  M_UInt           index;
  M_LHNode         node, *pnode;
  M_EqualDataFunc  equal;

  index = hash & table->mask;
  if ( index < table->p )
    index = hash & (2*table->mask+1);

  pnode = table->buckets + index;
  equal = table->node_equal;
  for (;;)
  {
    node = *pnode;
    if ( node == NULL )
      break;

    if ( node->hash == hash && equal( key_node, node, table->node_data ) )
      break;

    pnode = &node->link;
  }

  return (M_LHLookup)pnode;
}
