#include <mlib/internal/ilhash.h>

MLIB_APIDEF( void )
m_lhash_remove( M_LHash     table,
                M_LHLookup  lookup )
{
  M_LHNode  node;
  M_UInt    num_buckets;

  m_assert( lookup != NULL && *lookup != NULL );

  node       = *lookup;
  *lookup    = node->link;
  node->link = NULL;

  num_buckets = ( table->p + table->mask + 1 );

  if ( ++ table->slack > (M_Int) num_buckets * M_LHASH_SUB_LOAD )
  {
    M_UInt     p         = table->p;
    M_UInt     mask      = table->mask;
    M_UInt     old_index = p + mask;
    M_LHNode*  pnode;
    M_LHNode*  pold;

    if ( old_index < M_LHASH_INITIAL_SIZE )
      return;

    if ( p == 0 )
    {
      M_Memory  memory = table->memory;

      table->mask >>= 1;
      p             = table->mask;

      M_RENEW_ARRAY( table->buckets, (mask+1)*2, (mask+1) );
    }
    else
      p --;

    pnode = table->buckets + p;
    while ( *pnode )
      pnode = &(*pnode)->link;

    pold   = table->buckets + old_index;
    *pnode = *pold;
    *pold  = NULL;

    table->slack -= M_LHASH_MAX_LOAD;
    table->p      = p;
  }
}
