/* this simple C program is used to generate the configuration header */
/* file named "mconfcfg.h" at build time..                            */

#include <stdlib.h>
#include <stdio.h>

typedef void (*funcptr_t)( void );

int  main( void )
{
  /* first, the integer size types */
  printf( "/* this file was automatically generated. do not edit !! */\n"
          "\n"
          "#define  M_SIZEOF_CHAR     %d\n"
          "#define  M_SIZEOF_SHORT    %d\n"
          "#define  M_SIZEOF_INT      %d\n"
          "#define  M_SIZEOF_LONG     %d\n"
          "#define  M_SIZEOF_PTR      %d\n"
          "#define  M_SIZEOF_FUNCPTR  %d\n"
          "\n",
          sizeof(char),
          sizeof(short),
          sizeof(int),
          sizeof(long),
          sizeof(void*),
          sizeof(funcptr_t) );

  /* now, test endianess */
  {
    unsigned short val = 0x1234;
    unsigned char* p   = (unsigned char*)&val;

    if ( p[0] == 0x12 && p[1] == 0x34 )
    {
      printf( "#define  M_CONFIG_HAS_ENDIANESS\n"
              "#define  M_CONFIG_BIG_ENDIAN\n" );
    }
    else if ( p[0] == 0x34 && p[1] == 0x12 )
    {
      printf( "#define  M_CONFIG_HAS_ENDIANESS\n"
              "#define  M_CONFIG_LITTLE_ENDIAN\n" );
    }
    else
      printf( "#undef   M_CONFIG_HAS_ENDIANESS\n" );
  }

  /* what could we do else ?? */
}