#include <mlib/internal/imemory.h>

  MLIB_APIDEF(M_Pointer)
  m_mem_alloc  ( M_Size     size,
                 M_Memory   memory )
  {
    M_Pointer  result = 0;
    M_IMemory  internal = M_IMEMORY(memory);

    m_assert_is_memory( memory );

    if (size)
    {
#ifdef MLIB_CONFIG_OPTION_MEMORY_POOLS
      if ( internal->pool )
        M_MEMORY_POOL_ALLOC( internal->pool, size, result );
      else
#endif
      result = internal->alloc( size, memory );
      if (result)
      {
        /* clear memory block when needed */
        if (m_memory_need_block_clear( memory ))
          M_MEM_SET( result, 0, size );
      }
      else
      {
        /* throw an out-of-memory exception when needed */
        if ( m_memory_trap_enabled( memory ) && memory->mcore )
          m_core_throw( memory->mcore, m_err_memory_alloc );

        /* Panic otherwise */
        M_PANIC(( "%s: unhandled memory shortage exception !!\n",
                  "mem.alloc" ));
      }
    }
    return result;
  }


