#include <mlib/internal/imemory.h>

  MLIB_APIDEF(M_Error)
  m_mem_batch_qalloc( M_UInt      count,
                      M_Size*     sizes,
                      M_Pointer*  pointers,
                      M_Memory    memory )
  {
    M_UInt  n;

    m_assert_is_memory( memory );

    /* first of all, clear pointers table */
    for ( n = 0; n < count; n++ )
      pointers[n] = NULL;

    /* allocate each block one after the other */
    for ( n = 0; n < count; n++ )
    {
      M_Size     size;
      M_Pointer  ptr;

      size = sizes[n];
      ptr  = NULL;

      if ( size > 0 )
      {
        ptr = M_IMEMORY(memory)->alloc( size, memory );
        if ( ptr == NULL )
        {
          m_mem_batch_free( count, pointers, memory );
          return M_ERR_MEMORY_ALLOC;
        }
      }

      pointers[n] = ptr;
    }

    /* clear memory blocks when needed */
    if (m_memory_need_block_clear( memory ))
    {
      for ( n = 0; n < count; n++ )
      {
        M_Size     size = sizes[n];
        M_Pointer  ptr  = pointers[n];

        M_MEM_SET( ptr, 0, size );
      }
    }

    return 0;
  }


