#include <mlib/internal/imemory.h>

  MLIB_APIDEF(M_Pointer)
  m_mem_dup( M_Pointer  source,
             M_Size     size,
             M_Memory   memory,
             M_Bool     push )
  {
    M_IMemory  internal = M_IMEMORY(memory);
    M_Pointer  result   = NULL;

    m_assert_is_memory( memory );

    if (size)
    {
      result = internal->alloc( size, memory );
      if (!result)
      {
        /* throw an out-of-memory exception when needed */
        if ( m_memory_trap_enabled( memory ) && memory->mcore )
          m_core_throw( memory->mcore, m_err_memory_alloc );

        /* Panic otherwise */
        M_PANIC(( "%s: out of memory", "mem.dup" ));
      }

      M_MEM_COPY( result, source, size );
      if (push)
        m_mem_push( memory, result );
    }
    return result;
  }


