#include <mlib/ring.h>

  MLIB_APIDEF(void)
  m_ring_remove_node( M_Ring*  pring,
                      M_Ring   node )
  {
    M_Ring  first;
    M_Ring  prev, next;

    m_assert( pring );
    m_assert( node && node->prev && node->next );

    first = *pring;
    prev  = node->prev;
    next  = node->next;

    if ( next == node )
    {
      /* list has only one node */
      m_assert( prev == next && first == node );
      *pring = NULL;
    }
    else
    {
      prev->next = next;
      next->prev = prev;

      if ( node == first )
        *pring = next;
    }

    node->next = NULL;
    node->prev = NULL;
  }

