#include <mlib/internal/irope.h>

  static M_Size
  m_rope_compute_capacity( M_Size  org_size )
  {
    M_Size  new_size = 0;

    while ( new_size < org_size )
    {
      if ( new_size < 64 )
        new_size += 32;
      else
        new_size = new_size + (new_size >> 1) + 32;
    }

    return new_size;
  }


 /* reallocate a rope string when necessary */
  MLIB_APIDEF(void)
  m_rope_ensure( M_Rope   rope,
                 M_Size   new_size )
  {
    M_IRope  internal = M_IROPE(rope);
    M_Size   old_max  = internal->capacity;

    if ( new_size > old_max )
    {
      M_Memory  memory = internal->memory;

      new_size = m_rope_compute_capacity( new_size );

      M_REALLOC( rope->str, old_max, new_size );
      internal->capacity = new_size;
    }
  }


