#include <mlib/internal/irope.h>

 /* internal allocator */
  MLIB_LOCALDEF(M_Rope)
  m_rope_new_bound0( M_Memory   memory,
                     M_CString  init,
                     M_Size     len,
                     M_Bool     push )
  {
    M_Rope     rope;
    M_IRope    internal;
    M_Size     sizes[2];
    M_Pointer  ptrs[2];

    sizes[0] = sizeof(*internal);
    sizes[1] = len+1;

    /* allocate rope object and its string buffer in one operation */
    M_BATCH_ALLOC( 2, sizes, ptrs );

    internal           = ptrs[0];
    internal->memory   = memory;
    internal->capacity = sizes[1];

    rope      = &internal->root;
    rope->str = ptrs[1];
    if ( len > 0 )
    {
      M_MEM_COPY( rope->str, init, len );
      ((M_Byte*)rope->str)[len] = '\0';
    }
    rope->len = len;

    if (push)
      m_rope_push( rope );

    return rope;
  }


