#include <mlib/internal/irope.h>

  MLIB_APIDEF(void)
  m_rope_remove( M_Rope   target,
                 M_Int    start,
                 M_Int    len )
  {
    M_Int  delta;

    m_assert(target);

    if ( start < 0 )
    {
      len  += start;
      start = 0;
    }

    delta = start + len - target->len;
    if ( delta > 0 )
      len -= delta;

    if ( len > 0 )
    {
      M_Byte* p = (M_Byte*)target->str;

      M_MEM_MOVE( p + start, p + start + len, target->len - start - len );
      target->len   -= len;
      p[target->len] = '\0';
    }
  }


