#include <mlib/internal/istream.h>

  MLIB_API( M_Size )
  m_stream_read_some( M_Stream   stream,
                      M_ByteP    dest,
                      M_Size     count )
  {
    M_ByteP  d = dest;

    m_assert_is_stream( stream );

    if ( count > 0 )
    {
      M_StreamInfo  info = stream->info;
      M_Size        read;
      M_Byte*       d;

      /* flush stream when needed */
      if ( m_flags_test( info, M_STREAM_WRITING ) )
        m_stream_to_read( stream );

      /* invoke buffer read when needed */
      if ( info->buffer )
        return m_buffer_read( info->buffer, dest, count );

      /* raw read */
      d = dest;
      do
      {
        read   = M_STREAM_GET_CLASS(stream)->read( info->parent, d, count );
        d     += read;
        count -= read;
      }
      while ( read > 0 && count > 0 );
    }

    return (M_Size)( d - dest );
  }


