#include <mlib/internal/istream.h>

  MLIB_APIDEF( void )
  m_stream_seek( M_Stream      stream,
                 M_Dist        pos,
                 M_StreamSeek  anchor )
  {
    M_Stream_SeekFunc  seek;
    M_StreamInfo       info;

    m_assert_is_stream( stream );

    info = stream->info;
    seek = M_STREAM_GET_CLASS(stream)->seek;
    
    if ( seek == NULL )
      m_throw( stream, m_err_stream_seek );

    /* flush when needed */
    if ( m_flags_test( info, M_STREAM_WRITING ) )
      m_stream_to_read( stream );

    /* perform the seek */
    seek( stream->parent, pos, anchor );
  }


