#include <mlib/internal/istream.h>

  MLIB_APIDEF( M_Size )
  m_stream_write_some( M_Stream    stream,
                       M_CByteP    src,
                       M_Size      count )
  {
    M_CByteP  s = src;

    m_assert_is_stream( stream );

    if ( count > 0 )
    {
      M_StreamInfo  info = stream->info;
      M_Size        write;

      /* change flags */
      if ( !m_flags_test( info, M_STREAM_WRITING ) )
        m_stream_to_write( stream );

      /* invoke buffer routine when needed */
      if ( info->buffer )
        return m_buffer_write( info->buffer, src, count );

      /* perform raw write */
      do
      {
        write = M_STREAM_GET_CLASS(stream)->write( info->parent, src, count );

        s     += write;
        count -= write;
      }
      while ( write > 0 && count > 0 );
    }
    return (M_Size)( s - src );
  }


