#include <mlib/string.h>

  MLIB_APIDEF(M_Int)
  m_str_case_compare( M_CString  a,
                      M_CString  b )
  {
    static const M_CString  empty = "";
    M_Char                  ca, cb;
    M_Int                   result;

    if ( a == NULL )
      a = empty;

    if ( b == NULL )
      b = empty;

    for (;;)
    {
      M_Int  ca, cb;

      ca = *a; ca = M_TO_LOWER(ca);
      cb = *b; cb = M_TO_LOWER(cb);
      result = ca - cb;
      if ( result != 0 || ca == 0 )
        break;
      a++; b++;

      ca = *a; ca = M_TO_LOWER(ca);
      cb = *b; cb = M_TO_LOWER(cb);
      result = ca - cb;
      if ( result != 0 || ca == 0 )
        break;
      a++; b++;

      ca = *a; ca = M_TO_LOWER(ca);
      cb = *b; cb = M_TO_LOWER(cb);
      result = ca - cb;
      if ( result != 0 || ca == 0 )
        break;
      a++; b++;

      ca = *a; ca = M_TO_LOWER(ca);
      cb = *b; cb = M_TO_LOWER(cb);
      result = ca - cb;
      if ( result != 0 || ca == 0 )
        break;
      a++; b++;
    }
    return result;
  }

#ifdef M_CONFIG_OPTION_UNIT_TESTS

  static void
  m_str_case_compare__test( M_Test  test )
  {
    M_TEST_BEGIN
    {
      M_TEST_ASSERT( m_str_case_compare( NULL, NULL ) == 0 );
      M_TEST_ASSERT( m_str_case_compare( NULL, "" )   == 0 );
      M_TEST_ASSERT( m_str_case_compare( "", NULL )   == 0 );

      M_TEST_ASSERT( m_str_case_compare( NULL, "a" )   < 0 );
      M_TEST_ASSERT( m_str_case_compare( "a", NULL )   > 0 );
      M_TEST_ASSERT( m_str_case_compare( "", "a" )     < 0 );
      M_TEST_ASSERT( m_str_case_compare( "a", "" )     > 0 );

      M_TEST_ASSERT( m_str_case_compare( "a", "a" )   == 0 );
      M_TEST_ASSERT( m_str_case_compare( "A", "A" )   == 0 );
      M_TEST_ASSERT( m_str_case_compare( "a", "A" )   == 0 );
      M_TEST_ASSERT( m_str_case_compare( "A", "a" )   == 0 );

      M_TEST_ASSERT( m_str_case_compare( "a", "z" )    < 0 );
      M_TEST_ASSERT( m_str_case_compare( "a", "Z" )    < 0 );
      M_TEST_ASSERT( m_str_case_compare( "A", "z" )    < 0 );
      M_TEST_ASSERT( m_str_case_compare( "A", "Z" )    < 0 );

      M_TEST_ASSERT( m_str_case_compare( "z", "a" )    > 0 );
      M_TEST_ASSERT( m_str_case_compare( "z", "A" )    > 0 );
      M_TEST_ASSERT( m_str_case_compare( "Z", "a" )    > 0 );
      M_TEST_ASSERT( m_str_case_compare( "Z", "A" )    > 0 );

      M_TEST_ASSERT( m_str_case_compare( "cool", "COOL" )  == 0 );
      M_TEST_ASSERT( m_str_case_compare( "Cool", "cOOL" )  == 0 );
      M_TEST_ASSERT( m_str_case_compare( "cool", "COOL" )  == 0 );
      M_TEST_ASSERT( m_str_case_compare( "COOL", "cool" )  == 0 );

      M_TEST_ASSERT( m_str_case_compare( "cool", "hot" )    < 0 );
      M_TEST_ASSERT( m_str_case_compare( "cool", "HOT" )    < 0 );
      M_TEST_ASSERT( m_str_case_compare( "COOL", "hot" )    < 0 );
      M_TEST_ASSERT( m_str_case_compare( "COOL", "HOT" )    < 0 );

      M_TEST_ASSERT( m_str_case_compare( "hot", "cool" )    > 0 );
      M_TEST_ASSERT( m_str_case_compare( "hot", "COOL" )    > 0 );
      M_TEST_ASSERT( m_str_case_compare( "HOT", "cool" )    > 0 );
      M_TEST_ASSERT( m_str_case_compare( "HOT", "COOL" )    > 0 );
    }
    M_TEST_END
  }

#define  M_TEST_FUNCTION  m_str_case_compare__test
#define  M_TEST_NAME      "m_str_case_compare"
#include <mlib/tests-def.h>

#endif /* M_CONFIG_OPTION_UNIT_TESTS */
