#include <mlib/string.h>

  MLIB_APIDEF(M_Size)
  m_str_chr( M_CString  string,
             char       c )
  {
    M_CString  p = string;

    if ( p == NULL )
      return 0;

    for (;;)
    {
      M_Int  cp;

      cp = *p; if ( cp == 0 || cp == c ) break; p++;
      cp = *p; if ( cp == 0 || cp == c ) break; p++;
      cp = *p; if ( cp == 0 || cp == c ) break; p++;
      cp = *p; if ( cp == 0 || cp == c ) break; p++;
    }

    return (M_Size)( p - string );
  }


#ifdef M_CONFIG_OPTION_UNIT_TESTS

  static void
  m_str_chr__test( M_Test  test )
  {
    M_TEST_BEGIN
    {
      M_TEST_ASSERT( m_str_chr( NULL, 'a'  ) == 0 );
      M_TEST_ASSERT( m_str_chr( NULL, '\0' ) == 0 );

      M_TEST_ASSERT( m_str_chr( "abcdef", '\0' ) == 6 );
      M_TEST_ASSERT( m_str_chr( "abcdef", 'g'  ) == 6 );
      M_TEST_ASSERT( m_str_chr( "abcdef", 'a'  ) == 0 );
      M_TEST_ASSERT( m_str_chr( "abcdef", 'b'  ) == 1 );
      M_TEST_ASSERT( m_str_chr( "abcdef", 'c'  ) == 2 );
      M_TEST_ASSERT( m_str_chr( "abcdef", 'd'  ) == 3 );
      M_TEST_ASSERT( m_str_chr( "abcdef", 'e'  ) == 4 );
      M_TEST_ASSERT( m_str_chr( "abcdef", 'f'  ) == 5 );

      M_TEST_ASSERT( m_str_chr( "bcaaaa",     'a' ) == 2 );
      M_TEST_ASSERT( m_str_chr( "abbabbbabb", 'a' ) == 0 );
    }
    M_TEST_END
  }

#define  M_TEST_FUNCTION  m_str_chr__test
#define  M_TEST_NAME      "m_str_chr"
#include <mlib/tests-def.h>

#endif /* M_CONFIG_OPTION_UNIT_TESTS */

 