#include <mlib/string.h>

  MLIB_APIDEF(M_Size)
  m_str_rchr( M_CString  string,
              char       c )
  {
    M_CString  p = string;
    M_CString  r = NULL;

    if ( string == NULL )
      return 0;

    for (;;)
    {
      M_Int  cp;

      cp = *p;
      if ( cp == 0 ) break;
      if ( cp == c ) r = p;
      p++;

      cp = *p;
      if ( cp == 0 ) break;
      if ( cp == c ) r = p;
      p++;

      cp = *p;
      if ( cp == 0 ) break;
      if ( cp == c ) r = p;
      p++;

      cp = *p;
      if ( cp == 0 ) break;
      if ( cp == c ) r = p;
      p++;

    }

    if ( r == NULL )
      r = p;

    return (M_Size)( r - string );
  }

#ifdef M_CONFIG_OPTION_UNIT_TESTS

  static void
  m_str_rchr__test( M_Test  test )
  {
    M_TEST_BEGIN
    {
      M_TEST_ASSERT( m_str_rchr( NULL, 'a' ) == 0 );
      M_TEST_ASSERT( m_str_rchr( "", 'a' )   == 0 );

      M_TEST_ASSERT( m_str_rchr( "a", 'a' )      == 0 );
      M_TEST_ASSERT( m_str_rchr( "b", 'a' )      == 1 );
      M_TEST_ASSERT( m_str_rchr( "abba", 'a' )   == 3 );
      M_TEST_ASSERT( m_str_rchr( "abbacc", 'a' ) == 3 );
      M_TEST_ASSERT( m_str_rchr( "bbabbabb", 'a' ) == 5 );
    }
    M_TEST_END
  }

#define  M_TEST_FUNCTION  m_str_rchr__test
#define  M_TEST_NAME      "m_str_rchr"
#include <mlib/tests-def.h>

#endif /* M_CONFIG_OPTION_UNIT_TESTS */
 