#include <mlib/string.h>

  MLIB_APIDEF(M_Bool)
  m_str_start( M_CString  string,
               M_CString  prefix )
  {
    M_CString  s = string;
    M_CString  p = prefix;
    M_Int      cs, cp;

    /* an empty string always starts any other string */
    if ( p == NULL || p[0] == 0 )
      return 1;

    /* if the string is NULL, we only return true when the prefix */
    /* is NULL too..                                              */
    if ( s == NULL || s[0] == 0 )
      return 0;

    for (;;)
    {
      cs = *s; cp = *p;
      if ( cs == 0 || cp == 0 || cs != cp ) break;
      p++; s++;

      cs = *s; cp = *p;
      if ( cs == 0 || cp == 0 || cs != cp ) break;
      p++; s++;

      cs = *s; cp = *p;
      if ( cs == 0 || cp == 0 || cs != cp ) break;
      p++; s++;

      cs = *s; cp = *p;
      if ( cs == 0 || cp == 0 || cs != cp ) break;
      p++; s++;

    }
    return ( cp == 0 );
  }

#ifdef M_CONFIG_OPTION_UNIT_TESTS

  static void
  m_str_start__test( M_Test  test )
  {
    M_TEST_BEGIN
    {
      M_TEST_ASSERT( m_str_start( NULL, NULL ) != 0 );
      M_TEST_ASSERT( m_str_start( NULL, ""   ) != 0 );
      M_TEST_ASSERT( m_str_start( "", NULL   ) != 0 );
      M_TEST_ASSERT( m_str_start( "", "" )     != 0 );

      M_TEST_ASSERT( m_str_start( NULL, "a" ) == 0 );
      M_TEST_ASSERT( m_str_start( "", "a" )   == 0 );

      M_TEST_ASSERT( m_str_start( "a", NULL ) != 0 );
      M_TEST_ASSERT( m_str_start( "a", "" )   != 0 );

      M_TEST_ASSERT( m_str_start( "a", "a" ) != 0 );
      M_TEST_ASSERT( m_str_start( "a", "b" ) == 0 );

      M_TEST_ASSERT( m_str_start( "abcdef", "abc" ) != 0 );
      M_TEST_ASSERT( m_str_start( "abcdef", "bcd" ) == 0 );
    }
    M_TEST_END
  }

#define  M_TEST_FUNCTION  m_str_start__test
#define  M_TEST_NAME      "m_str_start"
#include <mlib/tests-def.h>

#endif /* M_CONFIG_OPTION_UNIT_TESTS */
 