#include <mlib/string.h>

  MLIB_API(M_Size)
  m_strn_append( M_String   target,
                 M_Size     target_size,
                 M_CString  source )
  {
    M_String   p     = target;
    M_CString  q     = source;
    M_Size     avail = target_size;

    /* first, parse the target to find its tail */
    for (;;)
    {
      if ( avail == 0 || *p == 0 ) break;
      p++; avail--;

      if ( avail == 0 || *p == 0 ) break;
      p++; avail--;

      if ( avail == 0 || *p == 0 ) break;
      p++; avail--;

      if ( avail == 0 || *p == 0 ) break;
      p++; avail--;
    }


    /* now, append the new string to it */
    if ( source && avail > 0 )
    {
      avail --;

      for (;;)
      {
        if ( *q == 0 || avail == 0 ) break;
        *p++   = *q++;
        avail -= 1;

        if ( *q == 0 || avail == 0 ) break;
        *p++   = *q++;
        avail -= 1;

        if ( *q == 0 || avail == 0 ) break;
        *p++   = *q++;
        avail -= 1;

        if ( *q == 0 || avail == 0 ) break;
        *p++   = *q++;
        avail -= 1;
      }

      /* _always_ zero terminate bounded string */
      *p = 0;
    }

    return (M_Size)( p - target );
  }


#ifdef M_CONFIG_OPTION_UNIT_TESTS

#include <stdlib.h>

  static void
  m_strn_append__test( M_Test  test )
  {
    M_TEST_BEGIN
    {
      M_Char  temp[ 200 ];

      M_MEM_SET( temp, 0xFF, sizeof(temp) );

      M_TEST_ASSERT( m_strn_append( temp, 0, "zool" ) == 0 );
      M_TEST_ASSERT( temp[0] == (M_Char)0xFF );

      temp[0] = 0;
      M_TEST_ASSERT( m_strn_append( temp, 1, "zool" ) == 0 );
      M_TEST_ASSERT( temp[0] == 0 );

      M_TEST_ASSERT( m_strn_append( temp, 2, "zool" ) == 1 );
      M_TEST_ASSERT( temp[0] == 'z' && temp[1] == 0 );

      temp[0] = 0;
      M_TEST_ASSERT( m_strn_append( temp, 4, "zool" ) == 3 );

      temp[0] = 0;
      M_TEST_ASSERT( m_strn_append( temp, sizeof(temp), "zool" ) == 4 );
      M_TEST_ASSERT( temp[0] == 'z' && temp[1] == 'o' && temp[2] == 'o' &&
                     temp[3] == 'l' && temp[4] == 0 );

      M_TEST_ASSERT( m_strn_append( temp, sizeof(temp), "baal" ) == 8 );

      temp[0] = 0;
      m_strn_append( temp, sizeof(temp), "zool" );
      M_TEST_ASSERT( m_strn_append( temp, 5, "baal" ) == 4 );
      M_TEST_ASSERT( m_strn_append( temp, 8, "baal" ) == 7 );
    }
    M_TEST_END
  }

#define  M_TEST_FUNCTION  m_strn_append__test
#define  M_TEST_NAME      "m_strn_append"
#include <mlib/tests-def.h>

#endif /* M_CONFIG_OPTION_UNIT_TESTS */
