#include <mlib/internal/itree.h>

  MLIB_APIDEF(M_Tree)
  m_tree_new_full( M_Memory           memory,
                   M_CompareDataFunc  key_compare,
                   M_DestroyDataFunc  key_destroy,
                   M_Pointer          key_data,
                   M_DestroyDataFunc  val_destroy,
                   M_Pointer          val_data )
  {
    M_Tree    tree;
    M_Memory  pool;
    m_assert_is_memory( memory );

    pool = m_memory_pool_find( memory, sizeof(M_TreeNodeRec) );

    M_NEW( tree );

    tree->memory      = memory;
    tree->magic       = M_TREE_MAGIC;
    tree->node_pool   = m_memory_pool_find( memory, sizeof(M_TreeNodeRec) );
    tree->root        = 0;
    tree->key_compare = key_compare;
    tree->key_destroy = key_destroy;
    tree->key_data    = key_data;
    tree->val_destroy = val_destroy;
    tree->val_data    = val_data;

    return tree;
  }

