#include <mlib.h>

#include <stdio.h>
#include <stdlib.h>

#define  M_LOG_DOMAIN     "MLIB_TESTS"
#define  M_LOG_COMPONENT  "Core"

  static M_Core      core;
  static M_Error     error;

  int main( void )
  {
    M_UInt  num_success = 0;
    M_UInt  num_failed  = 0;

    error = m_core_new( 0, 0, 0, &core );
    if (error)
      M_PANIC(( "%s: cannot create new MLib core, error = %04x\n",
                "mlib.test.core", error ));

    if ( !core )
      M_PANIC(( "%s: new MLib core handle is NULL !!",
                "mlib.test.core" ));

#ifdef M_CONFIG_OPTION_UNIT_TESTS

    m_core_add_test_classes( core, m_string__test_classes );

#endif /* M_CONFIG_OPTION_UNIT_TESTS */

    m_core_run_tests( core, 5, &num_success, &num_failed );

    printf( "success  = %d\nfailures = %d\n", num_success, num_failed );

    m_core_unref( core );

    exit(0);
    return 0;
  }

