#include <mlib.h>
#include <mlib/date.h>
#include <stdio.h>

#undef  M_LOG_DOMAIN
#define M_LOG_DOMAIN    "MLIB_TESTS"

#undef  M_LOG_COMPONENT
#define M_LOG_COMPONENT "Debug"


  static void
  test_dates()
  {
    M_DateRec  date, date2;

    /* clear a date and check that its content is invalid */
    m_date_clear( &date );
    if ( m_date_check( &date ) )
      m_panic( "date.clear: content of cleared date is valid" );

    /* check setting days */
    if ( m_date_set( &date, 1, 1, 2000 ) == FALSE ||
         m_date_check( &date )           == FALSE )
      m_panic( "date.set: 2000/1/1 is valid date" );

    if ( m_date_set( &date, 32, 1, 2000 ) == TRUE ||
         m_date_check( &date )            == TRUE )
      m_panic( "date.set: 2000/1/32 is invalid date" );

    if ( m_date_set( &date, 1, 32, 2000 ) == TRUE ||
         m_date_check( &date )            == TRUE )
      m_panic( "date.set: 2000/32/1 is invalid date" );

    if ( m_date_set( &date, 1, 1, 0 ) == TRUE ||
         m_date_check( &date )        == TRUE )
      m_panic( "date.set: 0000/1/1 is invalid date" );

    if ( m_date_set( &date, 29, 2, 2000 ) == FALSE )
      m_panic( "date.set: 2000 is a leap year" );

    if ( m_date_set( &date, 29, 2, 2001 ) == TRUE )
      m_panic( "date.set: 2001 is not a leap year" );
  }


  int main( void )
  {
    test_dates();

    fprintf( stderr, "test_date: ok\n" );
    return 0;
  }

