#include <stdlib.h>
#include <mlib.h>
#include <mlib/bytes.h>

typedef M_Int32   M_Int24;
typedef M_UInt32  M_UInt24;

#define  MACRO_IBE(_bits)  M_PEEK ## _bits ## _BE
#define  MACRO_ILE(_bits)  M_PEEK ## _bits ## _LE
#define  MACRO_UBE(_bits)  M_PEEK ## _bits ## _UBE
#define  MACRO_ULE(_bits)  M_PEEK ## _bits ## _ULE

#define  TYPE_I(_bits)    M_Int ## _bits
#define  TYPE_U(_bits)    M_UInt ## _bits

#define  NAME_IBE(_bits)   "M_PEEK" #_bits "_BE"
#define  NAME_ILE(_bits)   "M_PEEK" #_bits "_LE"
#define  NAME_UBE(_bits)   "M_PEEK" #_bits "_UBE"
#define  NAME_ULE(_bits)   "M_PEEK" #_bits "_ULE"

#define  TEST_IBE(_bits,_t,_val) \
             if ( MACRO_IBE(_bits) (_t) != (TYPE_I(_bits))_val )  \
                M_PANIC(( "%s: macro %s didn't work, got %4x instead of %4x\n", "test.struct", \
                          NAME_IBE(_bits), MACRO_IBE(_bits) (_t), _val ));

#define  TEST_UBE(_bits,_t,_val) \
             if ( MACRO_UBE(_bits) (_t) != (TYPE_U(_bits))_val )  \
                M_PANIC(( "%s: macro %s didn't work, got %4x instead of %4x\n", "test.struct", \
                          NAME_UBE(_bits), MACRO_UBE(_bits) (_t), _val   ));

#define  TEST_ILE(_bits,_t,_val) \
             if ( MACRO_ILE(_bits) (_t) != (TYPE_I(_bits))_val )  \
                M_PANIC(( "%s: macro %s didn't work, got %4x instead of %4x\n", "test.struct", \
                          NAME_ILE(_bits), MACRO_ILE(_bits) (_t), _val   ));

#define  TEST_ULE(_bits,_t,_val) \
             if ( MACRO_ULE(_bits) (_t) != (TYPE_U(_bits))_val )  \
                M_PANIC(( "%s: macro %s didn't work, got %4x instead of %4x\n", "test.struct", \
                          NAME_ULE(_bits), MACRO_ULE(_bits) (_t), _val   ));

  static const M_Byte  t[4] =
  {
    0x82, 0x53, 0x4C, 0xBE
  };

  static void
  test_peek( void )
  {
    TEST_IBE(16,t,0x8253)
    TEST_UBE(16,t,0x8253)
    TEST_IBE(24,t,0xFF82534C)
    TEST_UBE(24,t,0x0082534C)
    TEST_IBE(32,t,0x82534CBE)
    TEST_UBE(32,t,0x82534CBE)

    TEST_ILE(16,t,0x5382)
    TEST_ULE(16,t,0x5382)
    TEST_ILE(24,t,0x004C5382)
    TEST_ULE(24,t,0x004C5382)
    TEST_ILE(32,t,0xBE4C5382)
    TEST_ULE(32,t,0xBE4C5382)
  }

  int
  main( void )
  {
    test_peek();
    printf( "struct test: ok\n" );
    exit(0);
    return 0;
  }
